VERSION 5.00
Begin VB.Form dlgMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "CBT Example"
   ClientHeight    =   3900
   ClientLeft      =   45
   ClientTop       =   420
   ClientWidth     =   4620
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3900
   ScaleWidth      =   4620
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkmDisableSolitaire2 
      Caption         =   "Disable Solitaire (method 2)"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   3360
      Width           =   2535
   End
   Begin VB.CheckBox chkmDisableSolitaire1 
      Caption         =   "Disable Solitaire (method 1)"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   3000
      Width           =   2655
   End
   Begin VB.CommandButton btnmClose 
      Caption         =   "&Close"
      Height          =   375
      Left            =   3120
      TabIndex        =   3
      Top             =   3360
      Width           =   1335
   End
   Begin VB.TextBox txtmLog 
      Height          =   2535
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   360
      Width           =   4335
   End
   Begin VB.Label lblmLog 
      Caption         =   "Activity Log"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "dlgMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'SendMessage API is used to disable Solitaire (method 2).
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const WM_CLOSE = &H10


'Object to receive CBT events must be declared at
'class or form level.
Private WithEvents objmCbtEvents As CbtEvents

Private Sub btnmClose_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    'Start monitoring the system for CBT Events.
    Set objmCbtEvents = GetAllThreads.CbtEvents
End Sub

Private Sub LogAction(ByVal sAction As String)
    'Append the latest action to the first line of the TextBox,
    'so that newest actions appear first, oldest last.
    txtmLog.Text = sAction & vbCrLf & txtmLog.Text
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Need to set our object for receiving CBT events to Nothing
    'otherwise it will receive a DestroyWindow event for this
    'dialog - after it has been unloaded (which will result in an
    'error when the handler for the DestroyWindow event tries
    'to update a TextBox on the form).
    Set objmCbtEvents = Nothing
End Sub

Private Sub objmCbtEvents_DestroyWindow(Window As AkemiSpyLibrary.Window, Cancel As Boolean)
    LogAction "DestroyWindow" & Window.Caption
End Sub

Private Sub objmCbtEvents_MinMaxWindow(Window As AkemiSpyLibrary.Window, ByVal State As AkemiSpyLibrary.WindowStateConstants, Cancel As Boolean)
    Select Case State
        Case SW_MAXIMIZE
            LogAction "Maximize " & Window.Caption
        Case SW_MINIMIZE
            LogAction "Minimize " & Window.Caption
        Case SW_RESTORE
            LogAction "Restore " & Window.Caption
    End Select
End Sub

Private Sub objmCbtEvents_MoveSizeWindow(ByVal Window As AkemiSpyLibrary.Window, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long)
    LogAction "Move/Size " & Window.Caption
End Sub

Private Sub objmCbtEvents_SetFocus(Window As AkemiSpyLibrary.Window, PreviousWindow As AkemiSpyLibrary.Window, Cancel As Boolean)
    LogAction "SetFocus " & Window.Caption
End Sub

Private Sub objmCbtEvents_CreateWindow(Window As AkemiSpyLibrary.Window, Style As Long, ExStyle As Long, Cancel As Boolean)
    LogAction "CreateWindow (Class=" & Window.ClassName & ")"
    If chkmDisableSolitaire1.Value And Window.ClassName = "Solitaire" Then
        'Cancel the creation of the Solitaire window.
        'I know that the ClassName of the Solitaire Window is "Solitaire",
        'from running the ListOfOpenWindows example whilst an instance
        'of Solitaire is open.  The caption of the window cannot be checked
        'at this stage because the Window has not been created yet.
        
        'The solitaire application will interpret the failure to create a
        'window, as an "Out of Memory" error.
        Cancel = True
        LogAction "Solitaire Disabled"
        MsgBox "Sorry, you are not allowed to play Solitaire. (1)"
    End If
End Sub

Private Sub objmCbtEvents_ActivateWindow(Window As AkemiSpyLibrary.Window, Cancel As Boolean)
    LogAction "ActivateWindow " & Window.Caption
    If chkmDisableSolitaire2.Value And Window.Caption = "Solitaire" Then
        'This method of disabling Solitaire is better, because
        'it waits until Solitaire has successfully created its window,
        'so the Solitaire application will not be confused.
        'Also, by the time a window is about to be activated, its
        'caption has been set, so it is possible to block a window
        'based on either ClassName or Caption.
        Cancel = True
        SendMessage Window, WM_CLOSE, 0, 0
        MsgBox "Sorry, you are not allowed to play Solitaire (2)"
    End If
End Sub

